<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>User detail</title>

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
      integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO"
      crossorigin="anonymous"
    />
  </head>
  <body onload="onPageLoading()">
    <div class="container jumbotron">
      <h1 class="text-center p-lg-1">Thông tin người dùng</h1>
      <div class="form-group">
        <label for="">First Name</label>
        <input id="input-first-name" type="text" class="form-control" />
      </div>
      <div class="form-group">
        <label for="">Last Name</label>
        <input id="input-last-name" type="text" class="form-control" />
      </div>
      <div class="form-group">
        <label for="">Country</label>
        <input id="input-country" type="text" class="form-control" />
      </div>
      <div class="form-group">
        <label for="">Subject</label>
        <textarea
          id="textarea-subject"
          name=""
          id=""
          class="form-control"
        ></textarea>
      </div>
      <div class="form-row">
        <div class="col">
          <button
            id="button-edit"
            class="btn btn-success w-50"
            onclick="onBtnSuaClick()"
          >
            Sửa
          </button>
        </div>
        <div class="col">
          <a class="nav justify-content-end" onclick="onAQuayLaiClick()"
            >Quay lại</a
          >
        </div>
      </div>
    </div>
  </body>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL =
      "http://203.171.20.210:8080/devcamp-register-java-api/users";
    var gUserId = "";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi load trang
    function onPageLoading() {
      var vIdObj = {
        id: "",
      };
      //B1: lấy id từ trang web trước
      thuThapDuLieu(vIdObj);

      //B2: kiểm tra dữ liệu
      var vCheck = validateId(vIdObj.id);
      if (vCheck) {
        //B3: gọi api
        var vXHTMLRequest = new XMLHttpRequest();
        goiApi(vXHTMLRequest, vIdObj.id);
        vXHTMLRequest.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            //B4: hiển thị dữ liệu
            console.log(vXHTMLRequest.responseText);
            var bUserObj = JSON.parse(vXHTMLRequest.responseText);
            hienThiDuLieu(bUserObj);
          }
        };
      } else {
        history.back();
      }
    }

    //hàm thực thi khi nút Sửa được nhấn
    function onBtnSuaClick() {
      var vUserDataObject = {
        firstname: "",
        lastname: "",
        country: "",
        subject: "",
      };

      //B1: thu thập dữ liệu user đã sửa
      thuThapDuLieuUpdate(vUserDataObject);

      //B2: kiểm tra dữ liệu
      var vCheckUpdate = kiemTraDuLieuUpdate(vUserDataObject);
      if (vCheckUpdate) {
        //B3: gọi api để update dữ liệu đã sửa
        var vXMLHttp = new XMLHttpRequest();
        goiApiUpdate(vXMLHttp, vUserDataObject);
        vXMLHttp.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            // code xử lý response ở đây
            /*thêm code xử lý response*/
            alert("Cập nhật thông tin thành công");
            window.location.href = "task.29.60.html";
          }
        };
      }
    }

    //hàm thực thi khi nút Quay lại được nhấn
    function onAQuayLaiClick() {
      window.location.href = "task.29.60.html";
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm lấy id từ trang web trước
    function thuThapDuLieu(paramIdObj) {
      // get data from query string
      var vUrlString = window.location.href; //đường đẫn gọi đến trang
      console.log(vUrlString);
      var vUrl = new URL(vUrlString);

      // get parameters
      var vId = vUrl.searchParams.get("id");
      console.log(vId);
      if (vId != null) {
        paramIdObj.id = vId;
      } else {
        paramIdObj.id = "";
      }
      gUserId = paramIdObj.id;
    }

    //hàm kiểm tra dữ liệu
    function validateId(paramId) {
      if (paramId == "") {
        alert("Lỗi id");
        return false;
      }

      return true;
    }

    //hàm gọi api lấy user bằng id
    function goiApi(paramXHTMLRequest, paramId) {
      paramXHTMLRequest.open("GET", gBASE_URL + "/" + paramId, true);
      paramXHTMLRequest.send();
    }

    //hàm hiển thị dữ liệu
    function hienThiDuLieu(paramUserObj) {
      var vFirstnameInput = document.getElementById("input-first-name");
      var vLastnameInput = document.getElementById("input-last-name");
      var vCountryInput = document.getElementById("input-country");
      var vSubjectTextarea = document.getElementById("textarea-subject");

      vFirstnameInput.value = paramUserObj.firstname;
      vLastnameInput.value = paramUserObj.lastname;
      vCountryInput.value = paramUserObj.country;
      vSubjectTextarea.value = paramUserObj.subject;
    }

    // hàm thu thập dữ liệu user đã sửa
    function thuThapDuLieuUpdate(paramUserDataObject) {
      var vFirstnameInput = document.getElementById("input-first-name");
      var vLastnameInput = document.getElementById("input-last-name");
      var vCountryInput = document.getElementById("input-country");
      var vSubjectTextarea = document.getElementById("textarea-subject");

      var vFirstname = vFirstnameInput.value.trim();
      var vLastname = vLastnameInput.value.trim();
      var vCountry = vCountryInput.value.trim();
      var vSubject = vSubjectTextarea.value.trim();

      paramUserDataObject.firstname = vFirstname;
      paramUserDataObject.lastname = vLastname;
      paramUserDataObject.country = vCountry;
      paramUserDataObject.subject = vSubject;
    }

    //hàm kiểm tra dữ liệu
    function kiemTraDuLieuUpdate(paramUserDataObject) {
      if (paramUserDataObject.firstname == "") {
        alert("Bạn cần nhập firstname để sửa");
        return false;
      }

      if (paramUserDataObject.lastname == "") {
        alert("Bạn cần nhập lastname để sửa");
        return false;
      }

      if (paramUserDataObject.country == "") {
        alert("Bạn cần nhập country để sửa");
        return false;
      }

      if (paramUserDataObject.subject == "") {
        alert("Bạn cần nhập subject để sửa");
        return false;
      }

      return true;
    }

    //hàm gọi api để update dữ liệu đã sửa
    function goiApiUpdate(paramXMLHttp, paramUserDataObject) {
      var vUrlUpdateInfo = gBASE_URL + "/" + gUserId;
      paramXMLHttp.open("PUT", vUrlUpdateInfo);
      paramXMLHttp.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      paramXMLHttp.send(JSON.stringify(paramUserDataObject));
    }
  </script>
</html>
